diff -uNrd ircd-hybrid-6.2/src/m_gline.c ircd-hyb6.2-FEFr5/src/m_gline.c
--- ircd-hybrid-6.2/src/m_gline.c	Sun Aug  5 08:17:28 2001
+++ ircd-hyb6.2-FEFr5/src/m_gline.c	Tue Aug 21 01:36:52 2001
@@ -86,7 +86,7 @@
  * output       -
  * side effects -
  *
- * Place a G line if 3 opers agree on the identical user@host
+ * Place a G line if 2 opers agree on the identical user@host
  * 
  */
 /* Allow this server to pass along GLINE if received and
@@ -117,39 +117,32 @@
     {
 #ifdef GLINES
       /* Only globals can apply Glines */
-      if (!IsOper(sptr))
-        {
+      if (!IsOper(sptr)) {
           sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
           return 0;
-        }
+      }
 
-      if (!IsSetOperGline(sptr))
-        {
+      if (!IsSetOperGline(sptr)) {
           sendto_one(sptr,":%s NOTICE %s :You have no G flag",me.name,parv[0]);
           return 0;
-        }
+      }
 
-      if ( parc < 3 )
-        {
+      if ( parc < 3 ) {
           sendto_one(sptr, form_str(ERR_NEEDMOREPARAMS),
                      me.name, parv[0], "GLINE");
           return 0;
-        }
+      }
       
-      if ( (host = strchr(parv[1], '@')) || *parv[1] == '*' )
-        {
+      if ( (host = strchr(parv[1], '@')) || *parv[1] == '*' ) {
           /* Explicit user@host mask given */
           
-          if(host)                      /* Found user@host */
-            {
+          if(host) {                    /* Found user@host */
               user = parv[1];   /* here is user part */
               *(host++) = '\0'; /* and now here is host */
-            }
-          else
-            {
+          } else {
               user = "*";               /* no @ found, assume its *@somehost */
               host = parv[1];
-            }
+          }
 
           if (!*host)           /* duh. no host found, assume its '*' host */
             host = "*";
@@ -160,29 +153,28 @@
           temphost[HOSTLEN] = '\0';
           user = tempuser;
           host = temphost;
-        }
-      else
-        {
+      } else {
           sendto_one(sptr, ":%s NOTICE %s :Can't G-Line a nick use user@host",
                      me.name,
                      parv[0]);
           return 0;
-        }
+      }
 
       if(invalid_wildcard(user, host))
       {
         sendto_one(sptr,
-	           ":%s NOTICE %s :Please include at least %d non-wildcard characters with the user@host",
+		   ":%s NOTICE %s :Please include at least %d non-wildcard characters with the user@host",
 		   me.name, parv[0], NONWILDCHARS);
-
-        return 0;
+ 
+	return 0;
       }
-
+ 
       /* pull the reason from parv[2] and check the glines valid */
       reason = parv[2];
-      
+
       if(invalid_gline(sptr, user, host, reason, 1))
-        return 0;
+	  return 0;
+      reason = parv[2];
 
       if (sptr->user && sptr->user->server)
         oper_server = sptr->user->server;
@@ -210,29 +202,29 @@
   else
     {
 #ifdef GLINES
-      struct Client *acptr;
-#endif      
-      
-      /* if its not my client, and its not a server.. we dont wanna know */
-      if(!IsServer(sptr))
-        return(0);
+	struct Client *acptr;
+#endif
 
-      /* Always good to be paranoid about arguments */
-      if(parc < 8)
-        return 0;
+    /* if its not my client, and its not a server.. we dont wanna know */
+    if(!IsServer(sptr)&&!IsSLine(sptr))
+      return(0);
 
-      oper_name = parv[1];
-      oper_username = parv[2];
-      oper_host = parv[3];
-      oper_server = parv[4];
-      user = parv[5];
-      host = parv[6];
-      reason = parv[7];
+    /* Always good to be paranoid about arguments */
+    if(parc < 8)
+      return 0;
 
-      sendto_serv_butone(sptr, ":%s GLINE %s %s %s %s %s %s :%s",
-                         sptr->name,
-			 oper_name,oper_username,oper_host,oper_server,
-			 user, host, reason);
+    oper_name = parv[1];
+    oper_username = parv[2];
+    oper_host = parv[3];
+    oper_server = parv[4];
+    user = parv[5];
+    host = parv[6];
+    reason = parv[7];
+
+    sendto_serv_butone(sptr, ":%s GLINE %s %s %s %s %s %s :%s",
+                       sptr->name,
+		       oper_name,oper_username,oper_host,oper_server,
+		       user, host, reason);
 
 #ifdef GLINES
       /* check theres enough non-wildcard chars after we send it, our limit
@@ -240,10 +232,10 @@
       if(invalid_wildcard(user, host))
       {
         sendto_realops("%s!%s@%s on %s is requesting a gline without %d non-wildcard characters for [%s@%s] [%s]",
-	               oper_name, oper_username, oper_host, oper_server,
-		       NONWILDCHARS, user, host, reason);
+                     oper_name, oper_username, oper_host, oper_server,
+                     NONWILDCHARS, user, host, reason);
         return 0;
-      }	
+      }
 
       acptr=find_client(oper_name, NULL);
 
@@ -254,35 +246,36 @@
        *    knows what server it came from..
        * -- fl_
        */
-      
+
       if(!acptr)
 #ifdef NO_FAKE_GLINES
         return 0;
-#else	
+#else
         acptr=sptr;
 #endif /* NO_FAKE_GLINES */
 
       if(invalid_gline(acptr, user, host, reason, 0))
         return 0;
-	
-#endif /* GLINES */     
-      
-    }
+
+#endif /* GLINES */
+
+   }
 #ifdef GLINES
 
-   log_gline_request(oper_name,oper_username,oper_host,oper_server,
-                     user,host,reason);
+  log_gline_request(oper_name,oper_username,oper_host,oper_server,
+                    user,host,reason);
 
-   sendto_realops("%s!%s@%s on %s is requesting gline for [%s@%s] [%s]",
-                  oper_name,
-                  oper_username,
-                  oper_host,
-                  oper_server,
-                  user,
-                  host,
-                  reason);
+  sendto_realops("%s!%s@%s on %s is requesting gline for [%s@%s] [%s]",
+                 oper_name,
+                 oper_username,
+                 oper_host,
+                 oper_server,
+                 user,
+                 host,
+                 reason);
 
-  /* If at least 3 opers agree this user should be G lined then do it */
+  /* If at least 2 opers agree this user should be G lined then do it */
+  /* Exception: If the server is S-Lined, add it anyways! */
   if(majority_gline(sptr,
                     oper_name,
                     oper_username,
@@ -290,36 +283,35 @@
                     oper_server,
                     user,
                     host,
-                    reason))
-    {
-      current_date = smalldate((time_t) 0);
+                    reason) || IsSLine(sptr)) {
+    current_date = smalldate((time_t) 0);
           
-      aconf = make_conf();
-      aconf->status = CONF_KILL;
-      DupString(aconf->host, host);
+    aconf = make_conf();
+    aconf->status = CONF_KILL;
+    DupString(aconf->host, host);
 
-      ircsprintf(buffer, "%s (%s)",reason,current_date);
+    ircsprintf(buffer, "%s (%s)",reason,current_date);
       
-      DupString(aconf->passwd, buffer);
-      DupString(aconf->name, user);
-      aconf->hold = CurrentTime + GLINE_TIME;
-      add_gline(aconf);
+    DupString(aconf->passwd, buffer);
+    DupString(aconf->name, user);
+    aconf->hold = CurrentTime + GLINE_TIME;
+    add_gline(aconf);
       
-      sendto_realops("%s!%s@%s on %s has triggered gline for [%s@%s] [%s]",
-                     oper_name,
-                     oper_username,
-                     oper_host,
-                     oper_server,
-                     user,
-                     host,
-                     reason);
+    sendto_realops("%s!%s@%s on %s has triggered gline for [%s@%s] [%s]",
+                   oper_name,
+                   oper_username,
+                   oper_host,
+                   oper_server,
+                   user,
+                   host,
+                   reason);
       
-      rehashed = YES;
-      dline_in_progress = NO;
-      nextping = CurrentTime;
+    rehashed = YES;
+    dline_in_progress = NO;
+    nextping = CurrentTime;
 
-      return 0;
-    }
+    return 0;
+  }
 #endif  
   return 0;
 }
@@ -513,17 +505,6 @@
     return;
 
   ircsprintf(buffer, "#%s!%s@%s on %s [%s]\n",
-                   gline_pending_ptr->oper_nick2,
-                   gline_pending_ptr->oper_user2,
-                   gline_pending_ptr->oper_host2,
-                   gline_pending_ptr->oper_server2,
-                   (gline_pending_ptr->reason2)?
-                   (gline_pending_ptr->reason2):"No reason");
-
-  if (safe_write(sptr, filenamebuf, out, buffer))
-    return;
-
-  ircsprintf(buffer, "#%s!%s@%s on %s [%s]\n",
                    oper_nick,
                    oper_user,
                    oper_host,
@@ -691,22 +672,6 @@
                      gline_pending_ptr->host,
                      gline_pending_ptr->reason1);
 
-          if(gline_pending_ptr->oper_nick2[0])
-            {
-              tmptr = localtime(&gline_pending_ptr->time_request2);
-              strftime(timebuffer, MAX_DATE_STRING, "%Y/%m/%d %H:%M:%S", tmptr);
-              sendto_one(sptr,
-              ":%s NOTICE %s :2) %s!%s@%s on %s requested gline at %s for %s@%s [%s]",
-                         me.name,sptr->name,
-                         gline_pending_ptr->oper_nick2,
-                         gline_pending_ptr->oper_user2,
-                         gline_pending_ptr->oper_host2,
-                         gline_pending_ptr->oper_server2,
-                         timebuffer,
-                         gline_pending_ptr->user,
-                         gline_pending_ptr->host,
-                         gline_pending_ptr->reason2);
-            }
           gline_pending_ptr = gline_pending_ptr->next;
         }
       sendto_one(sptr,":%s NOTICE %s :End of Pending G-lines", me.name,
@@ -797,7 +762,6 @@
           tmp_pending_ptr = gline_pending_ptr;
           gline_pending_ptr = gline_pending_ptr->next;
           MyFree(tmp_pending_ptr->reason1);
-          MyFree(tmp_pending_ptr->reason2);
           MyFree(tmp_pending_ptr);
         }
       else
@@ -822,20 +786,16 @@
   memset(pending, 0, sizeof(GLINE_PENDING));
 
   strncpy_irc(pending->oper_nick1, oper_nick, NICKLEN);
-  /* pending->oper_nick2[0] = '\0'; */
 
   strncpy_irc(pending->oper_user1, oper_user, USERLEN);
-  /* pending->oper_user2[0] = '\0'; */
 
   strncpy_irc(pending->oper_host1, oper_host, HOSTLEN);
-   /* pending->oper_host2[0] = '\0'; */
 
   pending->oper_server1 = find_or_add(oper_server);
 
   strncpy_irc(pending->user, user, USERLEN);
   strncpy_irc(pending->host, host, HOSTLEN);
   DupString(pending->reason1, reason);
-  pending->reason2 = NULL;
 
   pending->last_gline_time = CurrentTime;
   pending->time_request1 = CurrentTime;
@@ -850,11 +810,11 @@
  * inputs       - oper_nick, oper_user, oper_host, oper_server
  *                user,host reason
  *
- * output       - YES if there are 3 different opers on 3 different servers
+ * output       - YES if there are 2 different opers on 2 different servers
  *                agreeing to this gline, NO if there are not.
  * Side effects -
  *      See if there is a majority agreement on a GLINE on the given user
- *      There must be at least 3 different opers agreeing on this GLINE
+ *      There must be at least 2 different opers agreeing on this GLINE
  *
  *      Expire old entries.
  */
@@ -872,42 +832,27 @@
 
   /* special case condition where there are no pending glines */
 
-  if (pending_glines == NULL) /* first gline request placed */
-    {
+  if (pending_glines == NULL) { /* first gline request placed */
       add_new_majority_gline(oper_nick, oper_user, oper_host, oper_server,
                              user, host, reason);
       return NO;
-    }
+  }
 
   expire_pending_glines();
 
   for (gline_pending_ptr = pending_glines;
-      gline_pending_ptr; gline_pending_ptr = gline_pending_ptr->next)
-    {
-      if( (irccmp(gline_pending_ptr->user,user) == 0) &&
-          (irccmp(gline_pending_ptr->host,host) ==0 ) )
-        {
+      gline_pending_ptr; gline_pending_ptr = gline_pending_ptr->next) {
+      if((irccmp(gline_pending_ptr->user,user) == 0) &&
+         (irccmp(gline_pending_ptr->host,host) == 0)) {
           if(((irccmp(gline_pending_ptr->oper_user1,oper_user) == 0) &&
-              (irccmp(gline_pending_ptr->oper_host1,oper_host) == 0)) ||
-              (irccmp(gline_pending_ptr->oper_server1,oper_server) == 0) )
-            {
+             (irccmp(gline_pending_ptr->oper_host1,oper_host) == 0)) ||
+             (irccmp(gline_pending_ptr->oper_server1,oper_server) == 0) ) {
               /* This oper or server has already "voted" */
               sendto_realops("oper or server has already voted");
               return NO;
-            }
-
-          if(gline_pending_ptr->oper_user2[0] != '\0')
-            {
-              /* if two other opers on two different servers have voted yes */
+          }
 
-              if(((irccmp(gline_pending_ptr->oper_user2,oper_user)==0) &&
-                  (irccmp(gline_pending_ptr->oper_host2,oper_host)==0)) ||
-                  (irccmp(gline_pending_ptr->oper_server2,oper_server)==0))
-                {
-                  /* This oper or server has already "voted" */
-                  sendto_realops("oper or server has already voted");
-                  return NO;
-                }
+          if(gline_pending_ptr->oper_user1[0] != '\0') {
 
               if(find_is_glined(host, user))
                 return NO;
@@ -919,20 +864,9 @@
                         oper_nick,oper_user,oper_host,oper_server,
                         user,host,reason);
               return YES;
-            }
-          else
-            {
-              strncpy_irc(gline_pending_ptr->oper_nick2, oper_nick, NICKLEN);
-              strncpy_irc(gline_pending_ptr->oper_user2, oper_user, USERLEN);
-              strncpy_irc(gline_pending_ptr->oper_host2, oper_host, HOSTLEN);
-              DupString(gline_pending_ptr->reason2, reason);
-              gline_pending_ptr->oper_server2 = find_or_add(oper_server);
-              gline_pending_ptr->last_gline_time = CurrentTime;
-              gline_pending_ptr->time_request1 = CurrentTime;
-              return NO;
-            }
-        }
-    }
+          }
+      }
+  }
   /* Didn't find this user@host gline in pending gline list
    * so add it.
    */
diff -uNrd ircd-hybrid-6.2/src/m_idle.c ircd-hyb6.2-FEFr5/src/m_idle.c
--- ircd-hybrid-6.2/src/m_idle.c	Wed Dec 31 19:00:00 1969
+++ ircd-hyb6.2-FEFr5/src/m_idle.c	Thu Oct 19 16:07:45 2000
@@ -0,0 +1,124 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, src/m_idle.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_help.c,v 1.1 1999/07/29 07:11:48 tomh Exp $
+ */
+#include <stdlib.h>
+#include "m_commands.h"
+#include "client.h"
+#include "ircd.h"
+#include "motd.h"
+#include "msg.h"
+#include "numeric.h"
+#include "send.h"
+#include "s_conf.h"
+
+/*
+ * m_functions execute protocol messages on this server:
+ *
+ *      cptr    is always NON-NULL, pointing to a *LOCAL* client
+ *              structure (with an open socket connected!). This
+ *              identifies the physical socket where the message
+ *              originated (or which caused the m_function to be
+ *              executed--some m_functions may call others...).
+ *
+ *      sptr    is the source of the message, defined by the
+ *              prefix part of the message if present. If not
+ *              or prefix not found, then sptr==cptr.
+ *
+ *              (!IsServer(cptr)) => (cptr == sptr), because
+ *              prefixes are taken *only* from servers...
+ *
+ *              (IsServer(cptr))
+ *                      (sptr == cptr) => the message didn't
+ *                      have the prefix.
+ *
+ *                      (sptr != cptr && IsServer(sptr) means
+ *                      the prefix specified servername. (?)
+ *
+ *                      (sptr != cptr && !IsServer(sptr) means
+ *                      that message originated from a remote
+ *                      user (not local).
+ *
+ *              combining
+ *
+ *              (!IsServer(sptr)) means that, sptr can safely
+ *              taken as defining the target structure of the
+ *              message in this server.
+ *
+ *      *Always* true (if 'parse' and others are working correct):
+ *
+ *      1)      sptr->from == cptr  (note: cptr->from == cptr)
+ *
+ *      2)      MyConnect(sptr) <=> sptr == cptr (e.g. sptr
+ *              *cannot* be a local connection, unless it's
+ *              actually cptr!). [MyConnect(x) should probably
+ *              be defined as (x == x->from) --msa ]
+ *
+ *      parc    number of variable parameter strings (if zero,
+ *              parv is allowed to be NULL)
+ *
+ *      parv    a NULL terminated list of parameter pointers,
+ *
+ *                      parv[0], sender (prefix string), if not present
+ *                              this points to an empty string.
+ *                      parv[1]...parv[parc-1]
+ *                              pointers to additional parameters
+ *                      parv[parc] == NULL, *always*
+ *
+ *              note:   it is guaranteed that parv[0]..parv[parc-1] are all
+ *                      non-NULL pointers.
+ */
+
+/*
+ * m_idle - Resets an oper's idle timer
+ *      parv[0] = sender prefix
+ *      parv[1] = idle time
+ *
+ * Original idea and code by Runt, clean-up and oper check by JailBird.
+ */
+#ifdef IDLE_RESET
+int m_idle(struct Client *cptr, struct Client *sptr, int parc, char *parv[])
+{
+  time_t	last = 0;
+
+  if (parc < 2) {
+      sendto_one(sptr, form_str(ERR_NEEDMOREPARAMS),
+                 me.name, parv[0], "IDLE");
+      return 0;
+  }
+  
+  if (!IsPerson(sptr) || !MyClient(sptr))
+      return 0;
+
+  if (!IsAnOper(sptr)) {
+      sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+      return 0;
+  }
+
+  last = atol(parv[1]);
+  if (last && CurrentTime - last < sptr->user->last && last > 0)
+    sptr->user->last = CurrentTime - last;
+   
+  return 0;
+}
+#endif /* IDLE_RESET */
diff -uNrd ircd-hybrid-6.2/src/m_info.c ircd-hyb6.2-FEFr5/src/m_info.c
--- ircd-hybrid-6.2/src/m_info.c	Tue Jul 17 21:37:13 2001
+++ ircd-hyb6.2-FEFr5/src/m_info.c	Mon Aug 20 23:32:39 2001
@@ -45,8 +45,10 @@
 
     if (!IsAnOper(sptr))
     {
+#ifndef INFO_OPER_ONLY
       /* reject non local requests */
       if (!MyConnect(sptr))
+#endif
         return 0;
       if ((last_used + PACE_WAIT) > CurrentTime)
       {
diff -uNrd ircd-hybrid-6.2/src/m_kill.c ircd-hyb6.2-FEFr5/src/m_kill.c
--- ircd-hybrid-6.2/src/m_kill.c	Sat Jun 30 23:13:55 2001
+++ ircd-hyb6.2-FEFr5/src/m_kill.c	Mon Aug 20 23:32:39 2001
@@ -176,6 +176,21 @@
 
   if (!IsServer(cptr))
     {
+#ifdef INU_SERV_CAN_COLLIDE
+	/*****************************************************
+	* If the kill reason is the INU_HACK_PASSWD, perform *
+	* a nick collision kill by sending on a NICK message *
+	* to all our up/downlinks. Then return. - inubus     *
+	*****************************************************/
+	if (IsOper(sptr) && (path!=NULL) && !strcmp(path,INU_HACK_PASSWD)) {
+		sendto_serv_butone(NULL, "NICK %s 1 1 + server collide.com %s :Collider", acptr->name, me.name);
+		sendto_serv_butone(NULL, ":%s QUIT :Collider", acptr->name);
+		sendto_realops("HACK: ServerCollide by %s for %s",
+			       parv[0], acptr->name);
+		return 0;
+	}
+#endif
+
       /*
       ** The kill originates from this server, initialize path.
       ** (In which case the 'path' may contain user suplied
@@ -232,6 +247,7 @@
 	}
     }
 
+if (!IsSLine(sptr)) {
   if (IsAnOper(sptr)) /* send it normally */
     {
       sendto_realops("Received KILL message for %s. From %s Path: %s!%s", 
@@ -256,6 +272,7 @@
     log(L_INFO,"KILL From %s For %s Path %s!%s",
                         parv[0], acptr->name, inpath, path);
 #endif
+}
   /*
   ** And pass on the message to other servers. Note, that if KILL
   ** was changed, the message has to be sent to all links, also
@@ -314,7 +331,10 @@
         }
       else
         killer = path;
+if (!IsSLine(sptr))
       ircsprintf(buf2, "Killed (%s)", killer);
+else
+      ircsprintf(buf2, "%s", killer);
     }
   return exit_client(cptr, acptr, sptr, buf2);
 }
diff -uNrd ircd-hybrid-6.2/src/m_list.c ircd-hyb6.2-FEFr5/src/m_list.c
--- ircd-hybrid-6.2/src/m_list.c	Tue Nov 21 01:49:30 2000
+++ ircd-hyb6.2-FEFr5/src/m_list.c	Thu Jan  4 01:37:17 2001
@@ -79,7 +79,11 @@
              (chptr) && (j<hash_get_channel_block(i).links); chptr=chptr->hnextch, j++) {
           if (j<progress2) continue;  /* wind up to listprogress2 */
           if (!sptr->user ||
-              (SecretChannel(chptr) && !IsMember(sptr, chptr)))
+              (SecretChannel(chptr) && !IsMember(sptr, chptr)
+#ifdef OPERS_SEE_PRIV
+	       && !IsAnOper(sptr)
+#endif
+	       ))
             continue;
           sendto_one(sptr, form_str(RPL_LIST), me.name, parv[0],
                      ShowChannel(sptr, chptr)?chptr->chname:"*",
@@ -116,8 +120,12 @@
         for (j=0, chptr = (struct Channel*)(hash_get_channel_block(i).list);
              (chptr) && (j<hash_get_channel_block(i).links); chptr = chptr->hnextch, j++) {
           if (!sptr->user ||
-              (SecretChannel(chptr) && !IsMember(sptr, chptr)))
-            continue;
+              (SecretChannel(chptr) && !IsMember(sptr, chptr)
+#ifdef OPERS_SEE_PRIV
+               && !IsAnOper(sptr)
+#endif
+	      ))
+           continue;
           /* EVIL!  sendto_one doesnt return status of any kind!  Forcing us
              to make up yet another stupid client flag (we could just
              negate the DOING_LIST flag, but that might confuse people) -good*/
diff -uNrd ircd-hybrid-6.2/src/m_ltrace.c ircd-hyb6.2-FEFr5/src/m_ltrace.c
--- ircd-hybrid-6.2/src/m_ltrace.c	Mon Jul 16 07:16:05 2001
+++ ircd-hyb6.2-FEFr5/src/m_ltrace.c	Mon Aug 20 23:32:39 2001
@@ -319,9 +319,12 @@
                  me.name, parv[0], 0, link_s[me.fd],
                  link_u[me.fd], me.name, "*", "*", me.name);
       sendto_one(sptr, form_str(RPL_ENDOFTRACE),me.name,
+		 parv[0],tname);
+      sendto_one(sptr, form_str(RPL_ENDOFTRACE),me.name,
                  parv[0],tname);
       return 0;
     }
+  sendto_one(sptr, form_str(RPL_ENDOFTRACE),me.name, parv[0],tname);
   sendto_one(sptr, form_str(RPL_ENDOFTRACE),me.name, parv[0],tname);
   return 0;
 }
diff -uNrd ircd-hybrid-6.2/src/m_message.c ircd-hyb6.2-FEFr5/src/m_message.c
--- ircd-hybrid-6.2/src/m_message.c	Sun Sep 10 04:42:49 2000
+++ ircd-hyb6.2-FEFr5/src/m_message.c	Mon Oct 23 22:44:52 2000
@@ -120,7 +120,7 @@
   struct Channel *chptr;
   char  *nick, *server, *cmd, *host;
   /* char *p; */
-  int type=0, msgs=0;
+  int type=0, msgs=0, ret=0;
 
   cmd = notice ? MSG_NOTICE : MSG_PRIVATE;
 
@@ -183,14 +183,21 @@
             check_for_flud(sptr, NULL, chptr, 1);
 #endif /* FLUD */
 
-      if (can_send(sptr, chptr) == 0)
-        sendto_channel_butone(cptr, sptr, chptr,
-                              ":%s %s %s :%s",
-                              parv[0], cmd, nick,
-                              parv[2]);
-      else if (!notice)
-        sendto_one(sptr, form_str(ERR_CANNOTSENDTOCHAN),
-                   me.name, parv[0], nick);
+      ret = IsSLine(sptr) ? 0 : can_send(sptr, chptr);
+      if (!ret && MyClient(sptr) && (chptr->mode.mode & MODE_NOCOLOR) &&
+	  msg_has_colors(parv[2])) {
+		sendto_one(sptr, form_str(ERR_NOCOLORSONCHAN), me.name, parv[0],
+			   nick, parv[2]);
+		msgs++;
+		continue;
+      }
+      if (ret)
+		sendto_one(sptr, form_str(ERR_CANNOTSENDTOCHAN), me.name,
+			   parv[0], nick);
+      else
+		sendto_channel_butone(cptr, sptr, chptr, ":%s %s %s :%s",
+				      parv[0], cmd, nick, parv[2]);
+
       msgs++;
       continue;
     }
diff -uNrd ircd-hybrid-6.2/src/m_mode.c ircd-hyb6.2-FEFr5/src/m_mode.c
--- ircd-hybrid-6.2/src/m_mode.c	Fri Jul 30 22:42:56 1999
+++ ircd-hyb6.2-FEFr5/src/m_mode.c	Mon Sep 11 02:16:06 2000
@@ -31,6 +31,10 @@
 #include "numeric.h"
 #include "s_user.h"
 #include "send.h"
+#include "struct.h"
+#include "s_conf.h"
+#include "common.h"
+#include "list.h"
 
 /*
  * m_functions execute protocol messages on this server:
@@ -144,6 +148,30 @@
                  chptr->chname, chptr->channelts);
       return 0;
     }
+
+#ifdef INU_SERVER_CAN_OP
+	/**********************************************************************
+	* Take the INU_HACK_PASSWD from where we put it earlier as indication *
+	* that this is a server op. Check if a server name was givem to seem  *
+	* to give the op. If not, use our name. Then op them. =) - inubus     *
+	**********************************************************************/
+	/* ircd 2.8.x will not allow us to use another server side,
+	 * so it HAS to come from us. -JailBird */
+	if (parc > 2 && MyClient(sptr) && !strcmp(parv[2],INU_HACK_PASSWD))
+        {
+                Link    *link;
+
+                if (link = find_user_link(chptr->members, sptr))
+                        link->flags |= CHFL_CHANOP;
+                sendto_serv_butone(sptr, ":%s MODE %s +o %s",
+                        me.name, chptr->chname, parv[0]);
+                sendto_channel_butserv(chptr, sptr, ":%s MODE %s +o %s",
+                        me.name, chptr->chname, parv[0]);
+                sendto_realops("HACK: ServerOps hack in %s by %s",
+                        chptr->chname, parv[0]);
+                return 0;
+	}
+#endif
 
   set_channel_mode(cptr, sptr, chptr, parc - 2, parv + 2);
 
diff -uNrd ircd-hybrid-6.2/src/m_oper.c ircd-hyb6.2-FEFr5/src/m_oper.c
--- ircd-hybrid-6.2/src/m_oper.c	Wed Aug 29 21:54:46 2001
+++ ircd-hyb6.2-FEFr5/src/m_oper.c	Sun Sep 30 20:18:04 2001
@@ -231,11 +231,7 @@
         }
 
       fdlist_add(sptr->fd, FDL_OPER | FDL_BUSY);
-#ifdef CUSTOM_ERR
-      sendto_ops("%s (%s@%s) has just acquired the personality of a petty megalomaniacal tyrant [IRC(%c)p]", parv[0],
-#else
       sendto_ops("%s (%s@%s) is now operator (%c)", parv[0],
-#endif /* CUSTOM_ERR */
                  sptr->username, sptr->host,
                  IsOper(sptr) ? 'O' : 'o');
       send_umode_out(cptr, sptr, old);
diff -uNrd ircd-hybrid-6.2/src/m_pong.c ircd-hyb6.2-FEFr5/src/m_pong.c
--- ircd-hybrid-6.2/src/m_pong.c	Fri Jun  9 22:45:36 2000
+++ ircd-hyb6.2-FEFr5/src/m_pong.c	Wed Sep 13 23:15:02 2000
@@ -28,6 +28,7 @@
 #include "numeric.h"
 #include "send.h"
 #include "channel.h"
+#include "s_stats.h"
 #include "irc_string.h"
 
 #ifdef DEBUGMODE
@@ -116,6 +117,35 @@
   cptr->flags &= ~FLAGS_PINGSENT;
   sptr->flags &= ~FLAGS_PINGSENT;
 
+#ifdef ANTI_IP_SPOOF
+  /* ANTI_IP_SPOOF delays the registration of a local client until after we
+     have received a response from a PING containing a random integer.  When
+     we receive the resulting PONG, then we register the client.
+  */
+
+  if(MyConnect(sptr) && !IsRegisteredUser(sptr) && sptr->random_ping) {
+      unsigned int received_random_ping;
+      received_random_ping = (unsigned int)atoi(origin);
+
+      if(received_random_ping) {
+          /* Ensure that aClient has a user and a nick (redundant) */
+          if((sptr->user) && (sptr->name[0])) {
+              if(received_random_ping == sptr->random_ping) {
+                  char buf[USERLEN + 1];
+                  strncpy_irc(buf, sptr->username, USERLEN);
+                  buf[USERLEN] = '\0';
+
+                  sptr->flags2 |= FLAGS2_GOT_ANTI_SPOOF_PING;
+                  register_user(cptr, sptr, sptr->name, buf);
+                  return 0;
+              } else {
+                 ServerStats->is_ipspoof++;
+                 return exit_client(cptr,sptr,&me,"Wrong randon PONG response.");
+              }
+          }
+      }
+  }
+#endif
 #ifdef NEED_SPLITCODE
 #ifdef SPLIT_PONG
   if (IsServer(cptr))
